unit DummyMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ImgList, ExtCtrls;

type
  TDummyMainForm = class(TForm)
    PopupMenu: TPopupMenu;
    MenuAbout: TMenuItem;
    MenuConfig: TMenuItem;
    MenuExit: TMenuItem;
    Timer1: TTimer;
    ImageList1: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure MenuAboutClick(Sender: TObject);
    procedure MenuConfigClick(Sender: TObject);
    procedure MenuExitClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    procedure TrayIconOnRightClick(Sender: TObject);
    procedure TrayIconOnLeftDblClick(Sender: TObject);
  public
  end;

var
  DummyMainForm: TDummyMainForm;

implementation

{$R *.dfm}

uses
    Config, iTray, Info, iReminder;

//-----------------------------------------------------------------------------
//  gCACRĂ΂郁\bh
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//  |bvAbvj[\
procedure TDummyMainForm.TrayIconOnRightClick(Sender: TObject);
begin
    SetForegroundWindow(Handle);
    PopupMenu.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
end;

//-----------------------------------------------------------------------------
//  ݒʕ\
procedure TDummyMainForm.TrayIconOnLeftDblClick(Sender: TObject);
begin
    SetForegroundWindow(Handle);
    MenuConfig.OnClick(MenuConfig);
end;

//-----------------------------------------------------------------------------
//  ^XNo[ɕ\Ȃ߂̃_~[CtH[
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TDummyMainForm.FormCreate(Sender: TObject);
var
    R: TRect;    
begin
    //  CtH[\
    Application.ShowMainForm := False;

    //  AvP[VEBhEB
    ShowWindow(Application.Handle, SW_HIDE);

    //  ^Ɉړ
    SystemParametersInfo(SPI_GETWORKAREA, 0, @R, 0);
    Self.Left := (R.Right - R.Left - Self.Width) div 2;
    Self.Top := (R.Bottom - R.Top - Self.Height) div 2;

    //  ݒǂݍ
    ConfigList.LoadFromFile(ChangeFileExt(ParamStr(0), '.dat'));

    //  gCACR\
    SimpleTray := TSimpleTaskTray.Create(Application.Icon.Handle);
    SimpleTray.FOnLeftDblClick := TrayIconOnLeftDblClick;
    SimpleTray.FOnRightClick := TrayIconOnRightClick;
    SimpleTray.AddTray(ExtractFileName(ParamStr(0)));

    Timer1.Enabled := true;
end;

//-----------------------------------------------------------------------------
//  I
procedure TDummyMainForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
    Timer1.Enabled := false;
    //  gCACR~
    SimpleTray.Free();

    //  ݒۑ
    ConfigList.SaveToFile(ChangeFileExt(ParamStr(0), '.dat'));
end;

//-----------------------------------------------------------------------------
//  w莞ԂH
procedure TDummyMainForm.Timer1Timer(Sender: TObject);
var
    Config: TReminderConfig;
    i: integer;
    Temp: TIcon;
    Icon: HICON;
begin
    Config := nil;
    if ConfigList.DoRemind(Config) then
    begin
        Temp := TIcon.Create;
        for i := 0 to ImageList1.Count - 1 do
        begin
            ImageList1.GetIcon(i, Temp);
            Icon := Temp.Handle;
            SimpleTray.ModTray(Icon);
            Sleep(100);
        end;
        Temp.Free;
        SimpleTray.ModTray(Application.Icon.Handle);
        Config.Execute();
    end;
end;

//-----------------------------------------------------------------------------
//  j[Cxgnh
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//  ̃vOɂ
procedure TDummyMainForm.MenuAboutClick(Sender: TObject);
begin
    OpenInfoForm();
end;

//-----------------------------------------------------------------------------
//  ݒʕ\
procedure TDummyMainForm.MenuConfigClick(Sender: TObject);
begin
    Timer1.Enabled := False;
    ShowConfigForm(Self);
    Timer1.Enabled := True;
end;

//-----------------------------------------------------------------------------
//  AvP[VI
procedure TDummyMainForm.MenuExitClick(Sender: TObject);
begin
    Self.Close();
end;

end.

